library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;


use work.control_unit_defs.all;
use work.constants.all;

entity decoder is
	port 
	(
		signal in_instruction : in ulv32_t; -- Instrukcija koja dolazi u Decoder

		signal out_s : out decoder_out_signals -- razbijena instrukcija
	);
end entity;

architecture rtl of decoder is

begin

	-- Pogledati PDF zasto je ovako
	out_s.op_type <= in_instruction(31 downto 29);
	out_s.op_code <= in_instruction(28 downto 25);
	out_s.rn <= in_instruction(24 downto 21);
	out_s.rd <= in_instruction(20 downto 17);
	out_s.s_bit <= to_bit_t(in_instruction(16 downto 16)); -- Mora ovako jer je in_instruction tipa std_ulogic_vector(....) a s_bit tipa std_ulogic
	out_s.rm <= in_instruction(15 downto 12);
	out_s.rs <= in_instruction(11 downto 8);
	out_s.shift_or_rot <= to_bit_t(in_instruction(7 downto 7)); -- Mora ovako jer je in_instruction tipa std_ulogic_vector(....) a s_bit tipa std_ulogic
	out_s.shift_rot_dir <= in_instruction(6 downto 5);
	out_s.immediate <= in_instruction(15 downto 0); -- Mora ovako jer je in_instruction tipa std_ulogic_vector(....) a s_bit tipa std_ulogic
	out_s.load_or_store <= to_bit_t(in_instruction(28 downto 28));
	out_s.jump_condition <= in_instruction(28 downto 27);
	out_s.branch_or_branch_and_link <= to_bit_t(in_instruction(26 downto 26)); -- Mora ovako jer je in_instruction tipa std_ulogic_vector(....) a s_bit tipa std_ulogic
	out_s.jump_offset <= in_instruction(25 downto 0);
  
end architecture;