-- Memorija za instrukcije
library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

use work.constants.all;

entity instruction_memory is

	generic 
	(
		DEFAULT_INST_MEM_CONTENT : inst_mem_array_t := (others => ZERO_ULV32_T) -- Postavlja se u startu memorija na 0. Generic je zato sto ce se load raditi iz test-a, odnosno fajla.
	);

	port 
	(
		in_address : in ulv32_t; --adresa sa koje se uzima
		out_data : out ulv32_t -- izlazna instrukcija
	);

end entity;

architecture rtl of instruction_memory is

	signal mem : inst_mem_array_t := DEFAULT_INST_MEM_CONTENT; -- memorija sa instrukcijama

begin

	out_data <= mem(to_integer(in_address)); -- izbaci instrukciju

end architecture;

