--Jedinica koja radi swap
library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

use work.constants.all;

entity swapper is
	port 
	(
		in_swap_instruction : in bit_t; -- da li se radi swap
		in_rd_data : in ulv32_t; -- ulazna vrednost rd
		in_rm_data : in ulv32_t; -- ulazna vrednost rm
		
		out_rd_data : out ulv32_t; -- izlazna vrednost rd
		out_rm_data : out ulv32_t -- izlazna vrednost rd
	);
end entity;

architecture rtl of swapper is
    
begin

	SWAP: process (all) is
	begin
		if (in_swap_instruction = '1') then -- radi se swap
			out_rd_data <= in_rm_data;
			out_rm_data <= in_rd_data;
		else 								-- ne radi se swap
			out_rd_data <= in_rd_data;
			out_rm_data <= in_rm_data;
		end if;
	end process;
  
end architecture;
