library ieee;
use ieee.std_logic_1164.std_ulogic_vector;
use STD.textio.all;
use IEEE.std_logic_1164.all;
use ieee.numeric_std.all;

use work.Constants.all;

use std.textio.all;
use ieee.numeric_std.all;


entity Decoder is
  port 
  (
    op_type_in  : in  bit_vector(3 downto 0); 
    op_type_out : out  op_code
    );
end entity Decoder;

architecture behavioral of Decoder is

begin

	Dispatch : process (op_type_in) 
	begin

		case op_type_in is
			when "0000" => op_type_out <= ALU_FN_AND;
			when "0001" => op_type_out <= ALU_FN_UNDEF_1;			
			when "0010" => op_type_out <= ALU_FN_SUB;
			when "0011" => op_type_out <= ALU_FN_UNDEF_3;			
			when "0100" => op_type_out <= ALU_FN_ADD;
			when "0101" => op_type_out <= ALU_FN_ADDC;
			when "0110" => op_type_out <= ALU_FN_SUBC;
			when "0111" => op_type_out <= ALU_FN_UNDEF_7;	
			when "1000" => op_type_out <= ALU_FN_SWAP;
			when "1001" => op_type_out <= ALU_FN_UNDEF_9;	
			when "1010" => op_type_out <= ALU_FN_CMP;
			when "1011" => op_type_out <= ALU_FN_UNDEF_11;	
			when "1100" => op_type_out <= ALU_FN_UNDEF_12;	
			when "1101" => op_type_out <= ALU_FN_MOV;
			when "1110" => op_type_out <= ALU_FN_UNDEF_14;	
			when "1111" => op_type_out <= ALU_FN_NOT;
			when others => op_type_out <= ALU_FN_AND;
		end case;

	end process Dispatch;

end architecture behavioral;