library ieee;
use ieee.std_logic_1164.all;

use work.constants.all;

package adder_defs is

type adder_in_signals is record
	operator_1 : ulv32_t; -- a
	operator_2 : ulv32_t; -- b
	csr_c : bit_t; -- carry bit
end record;

type adder_out_signals is record
	result : ulv32_t; -- rezultat operacije
	csr_n : bit_t; -- da li je negativan
	csr_z : bit_t; -- da li je nula
	csr_c : bit_t; -- da li je bilo carry
	csr_v : bit_t; -- da li je bio overflow
end record;

component adder_ripple_carry_with_zero_propagation is
	port
	(
		in_s : in adder_in_signals; -- ulazni podaci
		out_s : out adder_out_signals -- izlazni podaci
	);
end component;

component adder_ripple_carry_no_zero_propagation is
	port
	(
		in_s : in adder_in_signals; -- ulazni podaci
		out_s : out adder_out_signals -- izlazni podaci
	);
end component;

component adder_ripple_carry_function is
	port
	(
		in_s : in adder_in_signals; -- ulazni podaci
		out_s : out adder_out_signals -- izlazni podaci
	);
end component;

component adder_carry_look_ahead is
	port
	(
		in_s : in adder_in_signals; -- ulazni podaci
		out_s : out adder_out_signals -- izlazni podaci
	);
end component;

end package;
