library ieee;

use work.constants.all;

package full_adder_defs is

subtype ulv31_t is ulv_t(BUS_WIDTH - 2 downto 0);

type full_adder_1_bit_no_zero_in_signals is record
	a : bit_t; -- a
	b : bit_t; -- b
	c : bit_t; -- carry
end record;

type full_adder_1_bit_no_zero_out_signals is record
	sum : bit_t; -- rezultat sabiranja
	carry : bit_t; -- carry bit
end record;

type full_adder_1_bit_with_zero_in_signals is record
	a : bit_t; -- a
	b : bit_t; -- b
	c : bit_t; -- carry
	z : bit_t; -- nula
end record;

type full_adder_1_bit_with_zero_out_signals is record
	sum : bit_t; -- rezultat sabiranja
	carry : bit_t; -- carry bit
	zero : bit_t; -- prenos nule
end record;

Component full_adder_1_bit_no_zero is
	port 
	(
		in_s : in full_adder_1_bit_no_zero_in_signals; -- ulazni signali
		out_s : out full_adder_1_bit_no_zero_out_signals -- izlazni signali
	);
end component;

Component full_adder_1_bit_with_zero is
	port 
	(
		in_s : in full_adder_1_bit_with_zero_in_signals; -- ulazni signali
		out_s : out full_adder_1_bit_with_zero_out_signals -- izlazni signali
	);
end component;

end package;
