-- definicja alu
library ieee;
use ieee.std_logic_1164.all;

use work.constants.all;

package alu_defs is

type alu_in_signals is record
	alu_op : alu_fn_t; -- operacija koja se radi
	operator_1 : ulv32_t; -- a
	operator_2 : ulv32_t; -- b
	csr_c : bit_t; -- trenutno stanje c bita u CSR
end record;

type alu_out_signals is record
	result : ulv32_t; -- rezultat operacije
	csr_n : bit_t; -- da li je negativan
	csr_z : bit_t; -- da li je nula
	csr_c : bit_t; -- da li je bilo carry
	csr_v : bit_t; -- da li je bio overflow
end record;

component alu is
	generic
	(
		ADDER_TYPE : adder_t := RIPPLE_NO_ZERO_PROPAGATION -- tip dodavaca
	);
	port
	(
		in_s : in alu_in_signals; -- ulazni podaci
		out_s : out alu_out_signals -- izlazni podaci
	);
end component;

end package;
