library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

use work.logic_unit_defs.all;
use work.constants.all;

entity logic_unit is
	port
	(
		in_s : in logic_unit_in_signals; -- ulazni signali
		out_s : out logic_unit_out_signals -- izlazni signali
	);
end entity;

architecture rtl of logic_unit is

begin 

	Perform_Logic_OP: process(all)
	begin
		case in_s.operation is
			when LU_FN_AND =>
				out_s.result <= in_s.operator_1 AND in_s.operator_2;
				out_s.csr_n <= out_s.result(out_s.result'high);
				if (out_s.result = ZERO_ULV32_T) then
					out_s.csr_z <= '1';
				else
					out_s.csr_z <= '0';
				end if;
				out_s.csr_c <= '0';
				out_s.csr_v <= '0';

			when LU_FN_NOT =>
				out_s.result <= NOT in_s.operator_1;
				out_s.csr_n <= out_s.result(out_s.result'high);
				if (out_s.result = ZERO_ULV32_T) then
					out_s.csr_z <= '1';
				else
					out_s.csr_z <= '0';
				end if;
				out_s.csr_c <= '0';
				out_s.csr_v <= '0';

		end case;
	end process;

end architecture;      
