library ieee;
use ieee.std_logic_1164.all;

use work.constants.all;

package logic_unit_defs is

type logic_unit_in_signals is record
	operation : logic_unit_fn_t; -- tip operacije
	operator_1 : ulv32_t; -- a
	operator_2 : ulv32_t; -- b
end record;

type logic_unit_out_signals is record
	result : ulv32_t; -- rezultat operacije
	csr_n : bit_t; -- da li je negativan
	csr_z : bit_t; -- da li je nula
	csr_c : bit_t; -- da li je bilo carry
	csr_v : bit_t; -- da li je bio overflow
end record;

component logic_unit is
	port
	(
		in_s : in logic_unit_in_signals; -- ulazni signali
		out_s : out logic_unit_out_signals -- izlazni signali
	);
end component;

end package;
