-- fajl sa definicijama
library ieee;
use ieee.std_logic_1164.all;

use work.constants.all;

package memory_defs is

component instruction_memory is

	generic 
	(
		DEFAULT_INST_MEM_CONTENT : inst_mem_array_t := (others => ZERO_ULV32_T) -- Postavlja se u startu memorija na 0. Generic je zato sto ce se load raditi iz test-a, odnosno fajla.
	);

	port 
	(
		in_address : in ulv32_t; --adresa sa koje se uzima
		out_data : out ulv32_t -- izlazna instrukcija
	);

end component;

component data_memory is

	generic 
	(
		DEFAULT_DATA_MEM_CONTENT : data_mem_array_t := (others => ZERO_ULV32_T) -- Postavlja se u startu memorija na 0. Generic je zato sto ce se load raditi iz test-a, odnosno fajla.
	);

	port 
	(
		in_clk : in std_ulogic; --clock
		in_rst : in std_ulogic; --reset
		in_address : in ulv32_t; -- adresa za ispis/upis
		in_data	: in ulv32_t; -- podaci za upis
		in_we : in bit_t; -- da li se upisuje
		out_data : out ulv32_t -- izlazni podaci
	);

end component;

end package;
