library ieee;
use ieee.std_logic_1164.all;

use work.misc_defs.all;
use work.constants.all;

entity nor_reduce_zero is
	generic
	(
		NOR_REDUCTION_TYPE : nor_reduce_t := NOR_REDUCE
	);
	port
	(
		in_number : in ulv32_t;
		out_result : out bit_t
	);
end entity;

architecture rtl of nor_reduce_zero is

begin

	Reduction_Type: 
	case NOR_REDUCTION_TYPE 
	generate
	
		when NOR_REDUCE =>
			nor_reduce : process (all)
			variable zero : bit_t;
			begin
				zero := '0';
				for i in in_number'range loop
					zero := zero or in_number(i);
				end loop;
				out_result <= not zero;
			end process;
			
		when USING_LOOP =>
			loop_reduce : process (all)
			begin
				out_result <= '0';
				CHECK_LOOP:
				for i in in_number'range loop
					if (in_number(i) = '1') then
						out_result <= '1';
						exit CHECK_LOOP;
					end if;
				end loop;
			end process;
	
	end generate;

end architecture;
