library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

use work.constants.all;

entity sign_extender is
	port 
	(
		in_immediate : in immed_t; -- Immediate vrednost
		in_s_bit : in bit_t; -- Signed/Unsigned bit
    
		out_data : out ulv32_t -- Prosirena vrednost
	);
end entity;

architecture rtl of sign_extender is
    
begin

	process (all) is
	begin
		if (in_s_bit = SIGNED_OP) then
			out_data <= ulv32_t(resize(signed(in_immediate), ulv32_t'length)); -- ako je signed
		else
			out_data <= ulv32_t(resize(unsigned(in_immediate), ulv32_t'length)); -- ako je unsigned
		end if;
	end process;
  
end architecture;
