onerror {abort; }

echo -----> Create work library
if [file exists work] {
	vdel -all
	#file delete -force work
}
vlib work

echo -----> Calculating order and compile
project calculateorder

#echo -----> Compiling packages
#vcom -stats=none -work work -2008 -explicit VHD/Constants.vhd
#vcom -stats=none -work work -2008 -explicit VHD/Components.vhd
#vcom -stats=none -work work -2008 -explicit VHD/ALU.vhd
#vcom -stats=none -work work -2008 -explicit VHD/Controller.vhd
#vcom -stats=none -work work -2008 -explicit VHD/Processor.vhd
#vcom -stats=none -work work -2008 -explicit VHD/tests/test.vhd
#vcom -stats=none -work work -2008 -explicit VHD/tests/test_alu.vhd

echo -----> Start test
vsim test_alu

echo -----> Add waves
quietly WaveActivateNextPane {} 0
add wave -noupdate -radix decimal /test_alu/P_ALU/alu_op_in
add wave -noupdate -radix decimal /test_alu/TP_alu_op_in
add wave -noupdate -radix decimal /test_alu/P_ALU/reg_rn_in
add wave -noupdate -radix decimal /test_alu/TP_reg_rn_in
add wave -noupdate -radix decimal /test_alu/P_ALU/reg_rd_in
add wave -noupdate -radix decimal /test_alu/TP_reg_rd_in
add wave -noupdate -radix decimal /test_alu/P_ALU/reg_rm_in
add wave -noupdate -radix decimal /test_alu/TP_reg_rm_in
add wave -noupdate -radix decimal /test_alu/P_ALU/s_bit_in
add wave -noupdate -radix decimal /test_alu/TP_s_bit_in
add wave -noupdate -radix decimal /test_alu/P_ALU/csr_c_in
add wave -noupdate -radix decimal /test_alu/TP_csr_c_in
add wave -noupdate -radix decimal /test_alu/P_ALU/reg_rn_out
add wave -noupdate -radix decimal /test_alu/TP_reg_rn_out
add wave -noupdate -radix decimal /test_alu/P_ALU/reg_rd_out
add wave -noupdate -radix decimal /test_alu/TP_reg_rd_out
add wave -noupdate -radix decimal /test_alu/P_ALU/reg_rm_out
add wave -noupdate -radix decimal /test_alu/TP_reg_rm_out
add wave -noupdate -radix decimal /test_alu/P_ALU/result_out
add wave -noupdate -radix decimal /test_alu/TP_result_out
add wave -noupdate -radix decimal /test_alu/P_ALU/csr_n_out
add wave -noupdate -radix decimal /test_alu/TP_csr_n_out
add wave -noupdate -radix decimal /test_alu/P_ALU/csr_z_out
add wave -noupdate -radix decimal /test_alu/TP_csr_z_out
add wave -noupdate -radix decimal /test_alu/P_ALU/csr_c_out
add wave -noupdate -radix decimal /test_alu/TP_csr_c_out
add wave -noupdate -radix decimal /test_alu/P_ALU/csr_v_out
add wave -noupdate -radix decimal /test_alu/TP_csr_v_out
TreeUpdate [SetDefaultTree]
WaveRestoreCursors {{Cursor 1} {0 ns} 0}
quietly wave cursor active 0
configure wave -namecolwidth 150
configure wave -valuecolwidth 100
configure wave -justifyvalue left
configure wave -signalnamewidth 1
configure wave -snapdistance 10
configure wave -datasetprefix 0
configure wave -rowmargin 4
configure wave -childrowmargin 2
configure wave -gridoffset 0
configure wave -gridperiod 1
configure wave -griddelta 40
configure wave -timeline 0
configure wave -timelineunits ns
update
WaveRestoreZoom {0 ns} {100 ns}

echo -----> Run for 10 ns
run 10 ns
