-- Klasicki registar (koristimo ga za CSR)
library ieee;
use ieee.std_logic_1164.all;

use work.constants.all;

entity reg is
	generic
	(
		DEFAULT_RESET_VALUE : ulv32_t := ZERO_ULV32_T -- mora ovako jer se IR ne sme reset na 000000.. jer je to DP/R AND operacija
	);
	port
	(
		in_clk : in std_ulogic; -- ulazni clock
		in_rst : in std_ulogic; -- reset
		in_data : in ulv32_t; -- ulazni podaci
		in_we : in bit_t; -- dozvoljen upis
		out_data : out ulv32_t -- izlazni podaci
	);
end entity;

architecture rtl of reg is
signal reg : ulv32_t; --sam registar
begin
	process(in_clk, in_rst) begin
		if (in_rst = '1') then -- Ako je reset upisi 0
			reg <= DEFAULT_RESET_VALUE;
		elsif rising_edge(in_clk) then
			if(in_we = '1') then
				reg <= in_data; -- Ako je dozvoljen upis upisi vrednost
			end if;
		end if;
	end process;
	
	out_data <= reg; -- Vrati vrednost koja je u registru
end architecture;
